#!/usr/bin/perl

require "./config.pm";
require "./siteup.pm";
print &TopOfPage();
print &JavaScripts_ls();

if ($P{'action'} eq 'checkver')
{
	print &Operation("Check new version of indexsoft Site-UP");
	print qq{<p><iframe src="http://www.indexsoft.com/checkver.px?program=siteup&ver=$SiteUpVer&r=$rand" width="100%" height="60" marginwidth="0" marginheight="0" scrolling="no" frameborder="0">
	<SCRIPT LANGUAGE="JavaScript" TYPE="text/javascript" src="http://www.indexsoft.com/checkver.px?program=siteup&ver=$SiteUpVer&r=$rand&method=javascript"></SCRIPT>
	</iframe></p>};
}
if ($P{'action'} eq 'savefile' and $P{'file'})
{
	print &Operation("Save file $P{'file'} at $P{'dir'}");
	open(FILE, ">$P{'dir'}$DIRSEPARATOR$P{'file'}") || print &HoldError("can not write to file $P{'dir'}$DIRSEPARATOR$P{'file'}");
	binmode('FILE'); print FILE $P{'filecontent'}; close FILE;
	print &ReloadMenu();
}
if ($P{'action'} eq 'createnew')
{
	if ($P{'file'}) { foreach $file(split(/\0/, $P{'file'})) { if ($file) { print &Operation("Create file $file at $CURDIR"); &CreateFile($CURDIR, $file, $NEWFILETEMPLATE) } } }
	if ($P{'dirname'}) { foreach $dir(split(/\0/, $P{'dirname'})) { if ($dir) { print &Operation("Create directory $dir at $CURDIR"); mkdir ("$CURDIR$DIRSEPARATOR$dir", oct($CHMODDIRS)) || print &HoldError("can not create directory $CURDIR$DIRSEPARATOR$dir") } } }
	foreach $key(keys(%P))
	{
		if ($key =~ /uploadfile(\d+)/ && $P{$key}) { my $fid = $1; print &Operation(qq{Upload file $P{"uploadfile$fid"} at $CURDIR}); &UploadFile($CURDIR, $P{"uploadfile$fid"}, "uploadfile$fid"); }
	}
	print &ReloadMenu();
}
if ($P{'action'} eq 'deletefiles' and $P{'file'})
{
	print &Operation("Remove selected files and directories from $P{'dir'}");
	foreach $file(split(/\0/, $P{'file'}))
	{
		if (-d "$P{'dir'}$DIRSEPARATOR$file") { rmdir ("$P{'dir'}$DIRSEPARATOR$file") || print &HoldError("can not remove directory $P{'dir'}$DIRSEPARATOR$file") }
		else { unlink ("$P{'dir'}$DIRSEPARATOR$file") || print &HoldError("can not remove file $P{'dir'}$DIRSEPARATOR$file") }
	}
	print &ReloadMenu($CURDIRESCAPED);
}
if ($P{'action'} =~ 'chmodfiles' and $P{'file'})
{
	print &Operation("Chmod selected files and directories at $P{'dir'}");
	foreach $file(split(/\0/, $P{'file'})) {	(-d "$P{'dir'}$DIRSEPARATOR$file") ? ($chmodit = $P{'chmoddirs'}) : ($chmodit = $P{'chmodfiles'}); chmod (oct($chmodit), "$P{'dir'}$DIRSEPARATOR$file") || print &HoldError("can not chmod file $P{'dir'}$DIRSEPARATOR$file") }
}
if ($P{'action'} =~ 'renamefiles'  and $P{'file'})
{
	print &Operation("Rename selected files and directories at $P{'dir'}");
	foreach $file(split(/\0/, $P{'file'})) { if ($P{$file}) { rename ("$P{'dir'}$DIRSEPARATOR$file", "$P{'dir'}$DIRSEPARATOR$P{$file}") || print &HoldError("can not rename $P{'dir'}$DIRSEPARATOR$file to $P{'dir'}$DIRSEPARATOR$P{$file}") } }
	print &ReloadMenu($CURDIRESCAPED);
}
if ($P{'action'} eq 'cd')
{
	print &ReloadMenu($CURDIRESCAPED);
}

($dirdate) = &FileInfo($CURDIR); $qty = 0; $filessize = 0;
opendir (DIR, $CURDIR);
while ($file = readdir(DIR)) { (-d "$CURDIR$DIRSEPARATOR$file") ? do{push (@dirs, "$file") if ($file ne '.' and $file ne '..')} : push (@files, $file) }
@dirs = sort @dirs; @files = sort @files;
$i = 3;
$bgcolor = '#F9F9F9';
foreach $file(@dirs, @files)
{
	($filedate, $filesize, $fileurl) = &FileInfo("$CURDIR$DIRSEPARATOR$file");
	if (-d "$CURDIR$DIRSEPARATOR$file")
	{ $filesize = 'DIR'; $filename = qq{[<b><a href="ls.cgi?action=cd&dir=$CURDIR$DIRSEPARATOR$file" title="go to directory $file">$file</a></b>]}; }
	else
	{
		if (grep($file =~ /\.$_$/i , split(/\,/, "$TEXTFILES,$HTMLFILES"))) { $filename = qq{<a href="edit.cgi?dir=$CURDIR&file=$file" title="click to edit file">$file</a>} }
		else { $filename = $file; }
	}
	($bgcolor eq '#F9F9F9')?($bgcolor = '#FFFFFF'):($bgcolor = '#F9F9F9');
	$files .= qq{<tr bgcolor="$bgcolor" onmouseover="this.bgColor='#E8E8E8';" onmouseout="this.bgColor='$bgcolor';">
		<td><input type="checkbox" name="file" value="$file" title="select for action, double click to delete" ondblclick="self.location='ls.cgi?dir=$CURDIRESCAPED&action=deletefiles&file=$file'" onclick="filelistform.elements[$i].disabled = !filelistform.elements[$i].disabled"></td>
		<td title="double click to visit $fileurl" ondblclick="window.open('$fileurl','preview')">$filename</td>
		<td><input type="text" size="20" name="$file" class="linput" title="double click to insert file name" disabled ondblclick="filelistform.elements[$i].value = filelistform.elements[$i-1].value"></td>
		<td nowrap>$filedate</td>
		<td>$filesize</td>
	</tr>};
	$filessize += $filesize if $filesize ne 'DIR';
	$i += 2;
	++$qty;
}
closedir(DIR);
print &Header(qq{Selected directory $CURDIR | <a href="#" onclick="Synchronize(top.frames['menu'].curdir, false); return false;" title="Click to synchronize current directory with directory selected in menu">synchronize</a>});
print ''
.(($DOCUMENT_ROOT ne $CURDIR)
?(qq{<p>[ <a href="ls.cgi?action=cd&dir=$UPDIR">go up</a> ]</p>})
:(''))
.(($files)
?(qq{<form action="ls.cgi" method="post" name="filelistform">
	<input type="hidden" name="dir" value="$CURDIR">
	<table width="100%" border="0" cellspacing="0" cellpadding="0" bgcolor="#c0c0c0"><tr><td>
	<table width="100%" border="0" cellspacing="1" cellpadding="2">
	<tr bgcolor="#F9F9F9">
		<td><input title="invert selection" type="checkbox" onclick="for (var i=0;i<filelistform.elements.length;i++) { var z=filelistform.elements[i]; var zz=filelistform.elements[i+1]; if (z.name == 'file') { z.checked = !z.checked; zz.disabled = !zz.disabled; } }"></td>
		<td width="100%"><b>File name</b></td>
		<td nowrap><b>New name</b></td>
		<td nowrap><b>Last modified</b></td>
		<td><b>Size</b></td>
	</tr>	
	$files
</table></td></tr></table><br>
$filessize bytes at $qty files | directory created at $dirdate<br>
<blockquote>
	<input type="radio" name="action" value="deletefiles" onclick="CheckFileListForm()"> Delete selected files and directories<br>
	<input type="checkbox" name="action" value="renamefiles" onclick="CheckFileListForm()"> Rename selected files and directories<br>
	<input type="checkbox" name="action" value="chmodfiles" onclick="CheckFileListForm()"> Chmod selected files to: <input type="text" name="chmodfiles" value="$CHMODFILES" size="5" disabled> directories to <input type="text" name="chmoddirs" value="$CHMODDIRS" size="5" disabled><br>
</blockquote><input type="submit" name="submit" value="Delete selected" disabled></form>})
:(qq{<p><blockquote>No files found</blockquote></p>
	<form action="ls.cgi" method="post">
	<input type="hidden" name="action" value="deletefiles">
	<input type="hidden" name="dir" value="$UPDIR">
	<input type="hidden" name="file" value="$FILEDIR">
	<input type="submit" value="Delete empty directory"></form>
}));

print &Header(qq{Select an action | <a href="#" onclick="MoreFields(fields); return false;" title="only for MS Internet Explorer">more fields</a>});
print qq{<form action="ls.cgi" method="post" enctype="multipart/form-data">
<div id="fields">
<table width="100%" border="0" cellspacing="2" cellpadding="0"><tr>
<td>Create directory:<br><input type="text" name="dirname" size="20"></td>
<td>Create file:<br><input type="text" name="file" size="20"></td>
<td>Upload file:<br><input type="file" name="uploadfile1" size="20"></td>
</tr></table>
</div>
<br>
<input type="hidden" name="dir" value="$CURDIR">
<input type="hidden" name="action" value="createnew">
<input type="submit" value="Submit">
</form>};

print &BottomOfPage();

